%bcond_with bootstrap
%define gcj_support 1
%define priority 6000

Name:           gnu-crypto
Version:        2.1.0
Release:        %mkrel 6
Epoch:          0
Summary:        GNU Crypto library for Java

Group:          Development/Java
License:        LGPL-like
URL:            http://www.gnu.org/software/gnu-crypto/
Source0:        http://ftp.gnupg.org/GnuPG/gnu-crypto/gnu-crypto-%{version}-rc1.tar.bz2
Patch0:		%{name}-2.1.0.patch
Patch1:         %{name}-crosslink.patch
# javax.security.auth.* is already in J2SE >= 1.4.
Patch2:		%{name}-noauth.patch
Patch3:		%{name}-gcc41.patch
Patch4:		%{name}-gjdoc.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  ant, java-devel >= 0:1.4
%if !%{gcj_support}
Requires:       java >= 0:1.4
Requires:       jpackage-utils >= 0:1.6.3
%else
Requires:       jce
Requires:       jpackage-utils >= 0:1.6.3
%endif
Requires:       java-sasl
BuildRequires:	automake1.8
%if %{gcj_support}
# libgcj aot-compiled native libraries
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%else
BuildArch:      noarch
%endif

%description
GNU Crypto, part of the GNU project, released under the aegis of GNU,
aims at providing free, versatile, high-quality, and provably correct
implementations of cryptographic primitives and tools in the Java
programming language for use by programmers and end-users.

%package        der
Summary:        Gnu Crypto DER API
Group:          Development/Java
%if %{gcj_support}
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description    der
%{summary}.

%package        auth-jdk1.4
Summary:        Gnu Crypto AUTH API
Group:          Development/Java
Provides:       java-auth
%if %{gcj_support}
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description    auth-jdk1.4
%{summary}.

%package        sasl-jdk1.4
Summary:        Gnu Crypto SASL API
Group:          Development/Java
Provides:       java-sasl
%if %{gcj_support}
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description    sasl-jdk1.4
%{summary}.

%if %{gcj_support}
%package        jce-jdk1.4
Summary:        Gnu Crypto JCE API
Group:          Development/Java
Provides:       jce
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat

%description    jce-jdk1.4
%{summary}.
%endif

%if %without bootstrap
%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Java
BuildRequires:  java-javadoc

%description    javadoc
%{summary}.
%endif

%prep
%setup -q -n %{name}-%{version}-rc1
%patch0 -p1
%patch1 -p0
#%patch2 -p0
%if !%{gcj_support}
%patch3 -p0
%endif
%patch4 -p1


%build
%if %without bootstrap
%ant -Djdk2=true -Dj2se.apidoc=%{_javadocdir}/java jar javadoc2
%else
%ant -Djdk2=true -Dj2se.apidoc=%{_javadocdir}/java jar
%endif


%install
rm -rf $RPM_BUILD_ROOT

%if %{gcj_support}
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/java/security/security.d
touch $RPM_BUILD_ROOT%{_sysconfdir}/java/security/security.d/%{priority}-gnu.crypto.jce.GnuCrypto
%endif

install -dm 755 $RPM_BUILD_ROOT%{_javadir}
install -pm 644 lib/gnu-crypto-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar
%if %{gcj_support}
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed
ln -s %{_javadir}/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed/%{name}-%{version}.jar
%endif

install -pm 644 lib/gnu-crypto-der-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-der-%{version}.jar
ln -s %{name}-der-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-der.jar
%if %{gcj_support}
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed
ln -s %{_javadir}/%{name}-der-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed/%{name}-der-%{version}.jar
%endif

install -dm 755 \
  $RPM_BUILD_ROOT%{_javadir}-{ext,1.4.0,1.4.1,1.4.2}
install -pm 644 lib/javax-security-auth-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-auth-jdk1.4.jar
for javaver in 1.4.0 1.4.1 1.4.2 ; do
  ln -s %{_javadir}-ext/%{name}-auth-jdk1.4.jar \
    $RPM_BUILD_ROOT%{_javadir}-$javaver/auth.jar
done
%if %{gcj_support}
ln -s %{_javadir}-ext/%{name}-auth-jdk1.4.jar \
  $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed/%{name}-auth-jdk1.4.jar
%endif

install -dm 755 \
  $RPM_BUILD_ROOT%{_javadir}-{ext,1.4.0,1.4.1,1.4.2}
install -pm 644 lib/javax-security-sasl-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-sasl-jdk1.4.jar
for javaver in 1.4.0 1.4.1 1.4.2 ; do
  ln -s %{_javadir}-ext/%{name}-sasl-jdk1.4.jar \
    $RPM_BUILD_ROOT%{_javadir}-$javaver/sasl.jar
done
%if %{gcj_support}
ln -s %{_javadir}-ext/%{name}-sasl-jdk1.4.jar \
  $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed/%{name}-sasl-jdk1.4.jar
%endif

# The jce subpackage is required for libgcj which does not contain
# JCE.
%if %{gcj_support}
install -pm 644 lib/javax-crypto-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jce-jdk1.4.jar
for javaver in 1.4.0 1.4.1 1.4.2 ; do
  ln -s %{_javadir}-ext/%{name}-jce-jdk1.4.jar \
    $RPM_BUILD_ROOT%{_javadir}-$javaver/jce.jar
done
ln -s %{_javadir}-ext/%{name}-jce-jdk1.4.jar \
  $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed/%{name}-jce-jdk1.4.jar
%endif

%if %without bootstrap
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pR docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%check || :
# ant check # takes a looooong time


%clean
rm -rf $RPM_BUILD_ROOT


%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-security-providers ]; then %{_bindir}/rebuild-security-providers; fi
%{update_gcjdb}

%postun
if [ -x %{_bindir}/rebuild-security-providers ]; then %{_bindir}/rebuild-security-providers; fi
%{clean_gcjdb}

%post der
%{update_gcjdb}

%postun der
%{clean_gcjdb}

%post auth-jdk1.4
%{update_gcjdb}

%postun auth-jdk1.4
%{clean_gcjdb}

%post sasl-jdk1.4
%{update_gcjdb}

%postun sasl-jdk1.4
%{_bindir}/rebuild-gcj-db

%post jce-jdk1.4
%{update_gcjdb}

%postun jce-jdk1.4
%{clean_gcjdb}
%endif

%if %without bootstrap
%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}
%endif

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog COPYING README THANKS
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%if %{gcj_support}
%config(noreplace) %{_sysconfdir}/java/security/security.d/6000-gnu.crypto.jce.GnuCrypto
%{_javadir}/gcj-endorsed/%{name}-%{version}.jar
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files der
%{_javadir}/%{name}-der.jar
%{_javadir}/%{name}-der-%{version}.jar
%if %{gcj_support}
%{_javadir}/gcj-endorsed/%{name}-der-%{version}.jar
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-der-%{version}.jar.*
%endif

%files auth-jdk1.4
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog COPYING README THANKS
%{_javadir}-ext/%{name}-auth-jdk1.4.jar
%{_javadir}-1.4.0/auth.jar
%{_javadir}-1.4.1/auth.jar
%{_javadir}-1.4.2/auth.jar
%if %{gcj_support}
%{_javadir}/gcj-endorsed/%{name}-auth-jdk1.4.jar
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-auth-jdk1.4.jar.*
%endif

%files sasl-jdk1.4
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog COPYING README THANKS
%{_javadir}-ext/%{name}-sasl-jdk1.4.jar
%{_javadir}-1.4.0/sasl.jar
%{_javadir}-1.4.1/sasl.jar
%{_javadir}-1.4.2/sasl.jar
%if %{gcj_support}
%{_javadir}/gcj-endorsed/%{name}-sasl-jdk1.4.jar
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-sasl-jdk1.4.jar.*
%endif

%if %{gcj_support}
%files jce-jdk1.4
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog COPYING README THANKS
%{_javadir}-ext/%{name}-jce-jdk1.4.jar
%{_javadir}-1.4.0/jce.jar
%{_javadir}-1.4.1/jce.jar
%{_javadir}-1.4.2/jce.jar
%{_javadir}/gcj-endorsed/%{name}-jce-jdk1.4.jar
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-jce-jdk1.4.jar.*
%endif

%if %without bootstrap
%files javadoc
%defattr(644,root,root,755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}
%endif

%changelog
* Thu Aug 03 2006 David Walluck <walluck@mandriva.org> 0:2.1.0-6mdv2007.0
- use bcond

* Mon Jul 17 2006 David Walluck <walluck@mandriva.org> 0:2.1.0-5mdv2007.0
- rebuild due to lost src.rpm
- add bootstrap support

* Tue Jun 06 2006 David Walluck <walluck@mandriva.org> 0:2.1.0-4mdv2007.0
- don't bother running autogen.sh

* Tue Jun 06 2006 David Walluck <walluck@mandriva.org> 0:2.1.0-3mdv2007.0
- rebuild for libgcj.so.7
- change security provider priority

* Fri Jan 06 2006 David Walluck <walluck@mandriva.org> 0:2.1.0-2mdk
- fix aot-compile-rpm location
- fix compile with gjdoc shell script
- BuildRequires: automake1.8

* Mon Oct 24 2005 David Walluck <walluck@mandriva.org> 0:2.1.0-1mdk
- 2.1.0
- sync with 2.0.1-1jpp_7fc

* Wed May 11 2005 David Walluck <walluck@mandriva.org> 0:2.0.1-1.1mdk
- release

* Thu Apr 21 2005 Gary Benson <gbenson@redhat.com> - 0:2.0.1-1jpp_3fc
- Put the sasl endorsed jar in the correct subpackage.

* Wed Apr 13 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:2.0.1-1jpp_2fc
- Add gcj endorsed dir support.
- Add GnuCrypto security provider to classpath.security.

* Thu Nov  4 2004 Gary Benson <gbenson@redhat.com> - 0:2.0.1-1jpp_1fc
- Build into Fedora.

* Mon Jun 14 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.0.1-1jpp
- First build.
